#!/usr/bin/env python
######################################################################
#
# File: 	PyDebug.py
#
# Purpose:	Act as intermediary for user and gdb.  Intercept
#		import command and check for debugging.
#
# Version:	$Id: PyDebug.py,v 1.6 2001/05/22 19:17:51 pstoltz Exp $
#
# Copyright 2000 Tech-X Corporation, all rights reserved
#
######################################################################

import sys, fileinput, pty, termios, TERMIOS, os
from PyDebugGdbChild import *
from PyDebugGdbCmd import *
from string import *
from time import *
from thread import *
from re import *   # The 're' module contains a string function called match
from signal import *

##########
#
# This is the main program.  It forks a process and launches a thread 
# to listen to that process.  
#
##########
def main(argv):

  # Test that usage is correct
  if len(argv) < 3:
      print argv
      print "Usage: 'PyDebug debugger_name app_name' "
      sys.exit(0)
  else:
      debugger_name, app_name = argv[1], argv[2]
      sys.argv = "" # Do this so fileinput module reads from sdin

  # Set up needed variables
  nextline = "" 	#store the next line from std in
  breakcmds = {}	#dictionary of breakpoint and associated on/off flags
   
  # launch a PyDebugGdbChild
  myprocess=PyDebugGdbChild(debugger_name,app_name,breakcmds)
  
  # Create a filter
  filter = PyDebugGdbCmd(myprocess.ostr,breakcmds)
   
  # Infinite loop to read from stdin and filter
  #
  filter.cmdloop()

# Comment out for a minute
#
#  for line in fileinput.input():
#      filter.filterLine(line)
#  # if 'cntl-D' is sent, loop breaks
#  print 
#  print "PyDebug quitting..."
#  sys.exit(0)

if __name__ == '__main__':
  sys.exit(main(sys.argv))

